Bug 719879 (libguestfs_rebase6.3)

Summary: Rebase libguestfs in RHEL 6.3
Product: Red Hat Enterprise Linux 6 Reporter: Richard W.M. Jones <rjones>
Component: libguestfsAssignee: Richard W.M. Jones <rjones>
Status: CLOSED ERRATA QA Contact: Virtualization Bugs <virt-bugs>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 6.3CC: acathrow, degts, grant_williamson, jzheng, leiwang, moli, qwan, walicki
Target Milestone: rcKeywords: Rebase
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: libguestfs-1.16.19-1.el6 Doc Type: Rebase: Bug Fixes and Enhancements
Doc Text:
libguestfs has been rebased to a more recent upstream stable version. This new version has many new features and bug fixes, but remains backwards compatible with versions from earlier RHEL 6 releases.
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-06-20 02:59:33 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 719877, 731744, 734208, 751043    
Bug Blocks: 627835, 647174, 729076, 731742, 741183, 747667, 757071, 760221, 760223, 760226, 785305, 785668    
Attachments:
Description Flags
New features in libguestfs 1.8 -> 1.14 (RHEL 6.2 -> RHEL 6.3) none

Description Richard W.M. Jones 2011-07-08 05:20:29 EDT
This bug is a placeholder.  We should consider rebasing
libguestfs in RHEL 6.3 to upstream stable version 1.12.x

Background information:
  libguestfs version numbers:
    http://libguestfs.org/guestfs.3.html#libguestfs_version_numbers
  libguestfs ABI guarantee:
    http://libguestfs.org/guestfs.3.html#abi_guarantee

The case for rebasing:

In RHEL 6.1/6.2 we ship libguestfs 1.7.17 + about 80 patches
on top.  These patches effectively bring libguestfs up to
(approximately) upstream stable version 1.8.1.

There are about 100 *more* commits along the 1.8.x stable branch that
we should probably include, which would mean we are shipping
a total of nearly 200 patches (once you also include patches for
other bug fixes and enhancements).

It would make a lot more sense therefore to rebase, and if we're
going to rebase then we might as well go all the way up to
libguestfs 1.12.x since there are so many extra features, and
since we guarantee ABI stability upstream.

Some reasons NOT to rebase:

- Rebasing requires us to rebase febootstrap also (see bug 719877).
  This rebase is going to be quite complex.

- The OCaml language binding has changed in a non-compatible way,
  although IIRC this binding is in the Optional repo.  Note that
  language bindings aren't covered by the upstream ABI guarantee.

- As usual there is a risk of regressions.
Comment 2 Richard W.M. Jones 2011-08-18 17:36:48 EDT
There are 212 patches in libguestfs in RHEL 6.2.

$ ls -1 *.patch | wc -l
212

0001-df-Fix-segfault-when-using-virt-df-a-filename.patch
0002-protocol-Upload-progress-messages-and-optional-argum.patch
0003-protocol-Send-progress_hint-in-header.patch
0004-protocol-Really-read-4-bytes-while-checking-for-canc.patch
0005-protocol-Handle-progress-notification-messages-durin.patch
0006-Add-progress-notification-messages-to-upload-and-upl.patch
0007-Fix-argv-struct-mixup-over-Int-Int64.patch
0008-fish-Fix-generation-of-code-to-handle-Int-Int64-opti.patch
0009-generator-Code-to-handle-optional-arguments-in-daemo.patch
0010-appliance-Don-t-look-for-kmod.whitelist.patch
0011-New-API-mkfs_opts-mkfs-with-optional-arguments.patch
0012-regressions-Disable-test-for-576879.patch
0013-fuse-Fix-segfault-in-guestmount-verbose.patch
0014-fuse-Fix-emulation-of-open-call.patch
0015-docs-Note-that-guestfs_sync-is-no-longer-necessary.patch
0016-docs-Link-to-guestfs-examples-3-after-simple-example.patch
0017-rescue-Add-note-about-using-virt-rescue-as-root-non-.patch
0018-rescue-Add-notes-about-networking.patch
0019-fish-Remove-some-unused-local-variables.patch
0020-inspector-Remove-some-unused-local-variables.patch
0021-cat-Remove-some-unused-local-variables-in-virt-cat.c.patch
0022-Remove-several-unused-local-variables.patch
0023-win-reg-Move-documentation-after-options-combine-she.patch
0024-win-reg-Add-Windows-Tips-to-documentation.patch
0025-daemon-Use-prog_exists-to-check-for-features.patch
0026-appliance-Be-careful-about-cleaning-up-old-appliance.patch
0027-Remove-extra-n-character-from-end-of-error-messages.patch
0028-appliance-Touch-cached-appliance-files-so-they-don-t.patch
0029-appliance-Don-t-set-utime-on-cachedir-until-we-know-.patch
0030-fish-Split-.-.-options-into-separate-items-in-man-pa.patch
0031-fish-Document-equivalence-of-a-add-etc.-in-man-page.patch
0032-fish-Clarify-documentation-for-ro-option.patch
0033-appliance-Add-attr-package-for-xattr-support-in-virt.patch
0034-New-APIs-getxattr-and-lgetxattr-to-get-single-extend.patch
0035-ntfs-3g-Document-problems-with-symlinks-and-alternat.patch
0036-docs-Fix-link-to-function-in-documentation-of-du-and.patch
0037-docs-Add-section-on-using-dev-fd-with-upload-and-dow.patch
0038-appliance-Use-a-temporary-file-when-processing-packa.patch
0039-fuse-Add-more-tracing-for-calls-into-guestmount-func.patch
0040-docs-Refresh-README-file.patch
0041-docs-Obsolete-HACKING-file-move-content-into-guestfs.patch
0042-api-support-Fix-detection-of-similar-APIs.patch
0043-docs-Update-API-support.patch
0044-fish-ro-will-be-default-in-1.10-not-1.8.patch
0045-recipes-Refresh-guestfish-recipes.patch
0046-docs-Refresh-guestfs-3-MOUNTING.patch
0047-docs-Refresh-guestfs-3-DOWNLOADING.patch
0048-docs-Fix-missing-g-handle-in-guestfs-3-man-page.patch
0049-docs-Refresh-programming-language-equivalence-exampl.patch
0050-docs-Refresh-programming-language-list-in-guestfs-3.patch
0051-docs-add-domain-Remove-ref-to-not-impl-add-libvirt-d.patch
0052-podwrapper-builddir-was-not-defined-use-a-properly-d.patch
0053-podwrapper-Fix-script-indentation.patch
0054-podwrapper-Fix-up-the-HTML-output-so-most-inter-page.patch
0055-Lib.pm-avoid-message-unknown-filesystem-dev-fd0-RHBZ.patch
0056-Lib.pm-unknown-filesystem-label-SWAP-sda2-RHBZ-66657.patch
0057-Lib.pm-unknown-filesystem-dev-hd-x-cdrom-RHBZ-666577.patch
0058-inspector-Apps-in-Windows-VMs-are-now-listed-update-.patch
0059-Add-initial-announcement-to-release-notes.patch
0060-filesystems-Document-the-columns-in-long-output.patch
0061-.gitignore-Use-full-paths-for-some-ignored-files.patch
0062-fish-Fix-off-by-one-bug-in-tilde-expansion.patch
0063-fish-fails-to-tilde-expand-when-HOME-env-is-unset-RH.patch
0064-resize-Fix-typo-in-man-page-thanks-avesh-IRC.patch
0065-virt-filesystems-Ignore-errors-when-getting-label-an.patch
0066-fish-Don-t-fail-if-some-mountpoints-in-etc-fstab-are.patch
0067-virt-make-fs-Fix-typo-in-man-page.patch
0068-Add-a-prefix-to-output-when-tracing-RHBZ-673479.patch
0069-Fix-test-guestfish-a.sh-regression-test-for-new-trac.patch
0070-Fix-trace-segfault-for-non-daemon-functions-RHBZ-682.patch
0071-perl-Canonicalize-dev-vd-paths-in-old-inspection-cod.patch
0072-python-Convert-any-iterable-argument-to-a-list-RHBZ-.patch
0073-virt-make-fs-Round-disk-size-to-integer-fix-for-qemu.patch
0074-df-Skip-final-character-when-calculating-basename.patch
0075-inspect-Add-macros-for-file-size-limits.patch
0076-fish-exit_on_error-is-a-local-variable.patch
0077-fish-Make-exit_on_error-into-a-completely-local-vari.patch
0078-fish-Factor-out-command-line-parsing.patch
0079-fish-Initialize-pcmd-structure.patch
0080-fish-Fix-typo-in-error-message-copy-in-should-be-cop.patch
0081-packagelist-Add-ufsutils-for-Debian-and-Ubuntu.patch
0082-generator-Fix-generation-of-library-side-stubs-with-.patch
0083-mkfs-opts-Add-a-note-about-blocksize-param-and-UFS-f.patch
0084-daemon-Add-perror-to-two-exit-paths-to-make-errors-c.patch
0085-lib-Fix-use-after-free-bug-in-XPath-parsing-code.patch
0086-perl-Ignore-internal_-functions-in-POD-coverage-test.patch
0087-php-Ignore-another-generated-file-in-php-extension-d.patch
0088-lib-Move-appliance-launching-to-separate-function.patch
0089-daemon-change-to-root-directory.patch
0090-daemon-Ignore-return-value-from-chdir.patch
0091-java-Enable-assertions-when-doing-make-check.patch
0092-java-Remove-old-test-file-if-one-was-left-around.patch
0093-java-Fix-a-minor-whitespace-error-in-generated-code.patch
0094-java-Return-Map-String-String-for-RHashtable-functio.patch
0095-java-Fix-generated-functions-that-return-RHashtable.patch
0096-java-Add-a-test-of-g.list_filesystems-a-function-tha.patch
0097-Fix-inspection-code-when-PCRE-or-hivex-is-missing.patch
0098-virt-make-fs-In-debug-mode-print-qemu-img-command-li.patch
0099-generator-Introduce-error-code-errcode-concept.patch
0100-Include-locale.h-in-compilation-units-that-use-setlo.patch
0101-Detect-Red-Hat-Desktop-as-rhel-distro-RHBZ-682979.patch
0102-RHEL5-Make-use-of-futimens-function-optional.patch
0103-configure-Remove-unnecessary-variable-assignment.patch
0104-RHEL5-Old-pod2man-didn-t-have-stderr-or-u-options.patch
0105-check-the-pid-is-0-before-calling-waitpid.patch
0106-check-the-pid-is-0-before-calling-waitpid.patch
0107-regressions-Split-the-test-rhbz576879.sh-into-two-ha.patch
0108-regressions-Rename-the-file-we-are-uploading-too.patch
0109-haskell-Small-fixes-for-ghc-7.patch
0110-regressions-Enable-both-tests-for-bug-576879-not-fix.patch
0111-proto-Don-t-drop-outgoing-message-when-daemon-cancel.patch
0112-proto-Fix-FileIn-ops-that-abort-during-the-chunk-upl.patch
0113-proto-Fix-both-ends-cancel-case.patch
0114-fish-Add-all-stamp-.pod-files-to-CLEANFILES.patch
0115-guestfs-3-Indent-line-to-keep-code-together.patch
0116-guestfs-3-kernel-supermin-appliance.patch
0117-inspect-Simplify-Windows-root-heuristic-code.patch
0118-inspect-Don-t-fail-for-Windows-guests-with-multiple-.patch
0119-fish-Add-w-rw-option-to-help-output.patch
0120-fish-Add-better-quick-help-to-help-output.patch
0121-Rename-tmpdir-sock-to-tmpdir-guestfsd.sock.patch
0122-mkfs-Force-mke2fs-to-create-a-filesystem-even-on-raw.patch
0123-RHEL-5-Use-mke4fs-on-RHEL-5-as-replacement-for-mke2f.patch
0124-fuse-Fix-getxattr-listxattr-calls-and-add-a-regressi.patch
0125-README-Note-that-getfacl-getfattr-are-optional-depen.patch
0126-tests-Don-t-fail-when-compiled-without-support-for-N.patch
0127-Exclude-po-docs-directory-completely-if-po4a-not-ava.patch
0128-fuse-Document-w-flag-in-help-output.patch
0129-rescue-Add-w-rw-option.patch
0130-contrib-Fix-URLs-in-README-file.patch
0131-examples-size_t-correctness-change-in-inspect_vm.c.patch
0132-examples-Use-WARN_CFLAGS-WERROR_CFLAGS-macros-instea.patch
0133-docs-Progress-messages-don-t-necessarily-reach-100-i.patch
0134-Add-prototype-for-timeval_diff.patch
0135-daemon-Reset-SIGPIPE-to-default-before-running-subpr.patch
0136-daemon-When-running-commands-restart-select-if-we-re.patch
0137-cat-edit-Reference-guestfish-equivalent-commands-in-.patch
0138-edit-Let-root-roots-0.patch
0139-edit-Move-exit-0-to-end-of-file.patch
0140-Rename-resolve_windows_path_silently-to-case_sensiti.patch
0141-Compile-rpcgen-generated-files-with-fno-strict-alias.patch
0142-inspector-Include-hostname-in-output.patch
0143-inspector-Handle-write-failures-when-creating-exampl.patch
0144-fish-Fix-typo-in-guestfish-man-page-format-option.patch
0145-python-Release-Python-GIL-while-running-libguestfs-c.patch
0146-zero-Disable-file-test-because-of-bug-in-file-comman.patch
0147-list-applications-If-software-hive-is-missing-this-i.patch
0148-inspect-Look-for-systemroot-system32-for-Windows-heu.patch
0149-Document-that-guestfs_file-output-depends-on-file-1-.patch
0150-guestfs-examples-3-Remove-link-to-OCaml-homepage.patch
0151-daemon-Fix-error-message.patch
0152-virt-ls-Small-fix-for-output-of-help-option.patch
0153-Only-include-date-not-time-in-BUGS-file.patch
0154-protocol-Enhance-unexpected-end-of-file-when-reading.patch
0155-init-Remove-timeout-in-udevadm-settle-command.patch
0156-Coverity-Remove-unreachable-code.patch
0157-Coverity-Don-t-call-free_strings-NULL.patch
0158-Coverity-Avoid-calling-sort_strings-NULL-0-on-empty-.patch
0159-Coverity-Don-t-close-fd_cwd-if-fd_cwd-1.patch
0160-Coverity-Check-return-value-of-malloc.patch
0161-Coverity-Check-return-value-of-sysroot_path.patch
0162-Coverity-Don-t-leak-error-strings.patch
0163-Coverity-Don-t-leak-argv-arrays.patch
0164-Coverity-Close-directory-handle-along-error-paths.patch
0165-Coverity-Ensure-fp-is-closed-along-all-error-paths.patch
0166-Coverity-Missing-return-on-error-path.patch
0167-Coverity-Don-t-return-freed-pointers-from-command-al.patch
0168-daemon-Keep-Coverity-happy-by-ignoring-some-return-v.patch
0169-generator-Rewrite-UUIDs-that-begin-with-zero-byte.patch
0170-perl-Don-t-use-qw-as-parentheses.patch
0171-perl-Ignore-MYMETA.yml.patch
0172-trace-Print-empty-list-correctly.patch
0173-Revert-Lib.pm-unknown-filesystem-label-SWAP-sda2-RHB.patch
0174-inspector-Fix-comment-in-virt-inspector.rng.patch
0175-Add-caution-subdirectory-containing-safety-and-liven.patch
0176-protocol-Force-optargs_bitmask-to-be-passed-as-0-for.patch
0177-Document-that-ntfsresize-cannot-be-used-multiple-tim.patch
0178-part-get-bootable-Fix-when-partitions-are-missing-or.patch
0179-mkfs-Don-t-die-if-mke2fs-is-not-available.patch
0180-build-Fix-virtio-serial-test-for-qemu-0.15.patch
0181-appliance-Document-pipe-fds.patch
0182-appliance-Capture-stderr-from-qemu-to-the-event-syst.patch
0183-blkid-Detect-when-value-not-found-and-return-empty-s.patch
0184-blkid-Use-c-dev-null-option-to-kill-the-cache.patch
0185-build-Allow-make-quickcheck-test-tool-args-to-be-ove.patch
0186-build-Send-failed-Perl-test-configure-output-to-conf.patch
0187-build-Redirect-.-configure-errors-in-general-to-conf.patch
0188-perl-Fix-CCFLAGS-for-Perl-5.14.patch
0189-test-tool-Print-FEBOOTSTRAP_-environment-variables-R.patch
0190-virt-df-Re-add-documentation-for-csv-option.patch
0191-ocaml-Fix-locking-in-event-callbacks.patch
0192-perl-Fix-another-place-where-qw-was-used-as-parenthe.patch
0193-Don-t-fail-if-HOSTNAME-field-is-missing-on-Red-Hat-g.patch
0194-Change-link-since-PostgreSQL-switched-to-using-git.patch
0195-virt-tar-test-Stable-ordering-of-test-output.patch
0196-debian-Add-gawk-to-packagelist.patch
0197-debian-bash-is-required-to-run-libtool-replacement-s.patch
0198-docs-guestfs_set_out_of_memory_handler-returns-void-.patch
0199-docs-Fix-function-names-in-deprecation-notices.patch
0200-inspect-Detect-32-bit-applications-running-on-WOW64-.patch
0201-perl-Binding-and-test-for-guestfs_last_errno-RHBZ-67.patch
0202-New-API-list-dm-devices-RHBZ-688062.patch
0203-fish-Show-device-mapper-device-in-tab-completion-RHB.patch
0204-Fix-unknown-filesystem-warnings-in-old-inspection-co.patch
0205-fish-Document-that-remote-run-in-cmd-substitution-co.patch
0206-Note-that-additional-memory-may-be-required-to-typec.patch
0502-RHEL-6-Include-first-version-of-virt-inspector-fro.patch
0503-RHEL-6-Directly-include-String-ShellQuote.patch
0505-RHEL-6-Emphasize-libguestfs-winsupport-package-RHB.patch
0506-RHEL-6-Require-external-hex-editor-set-with.patch
0507-RHEL-6-Document-that-fullvirt-query-only-works-for-L.patch
libguestfs-1.7.13-no-fuse-test.patch
Comment 3 Richard W.M. Jones 2011-10-20 06:48:08 EDT
Created attachment 529233 [details]
New features in libguestfs 1.8 -> 1.14 (RHEL 6.2 -> RHEL 6.3)

ATTN QA:

This document summarises the new features that will be
added by this rebase.
Comment 4 John Walicki 2011-10-27 09:46:36 EDT
+1
Comment 5 Richard W.M. Jones 2011-11-16 06:45:32 EST
Preview packages are available:

http://people.redhat.com/~rjones/libguestfs-RHEL-6.3-preview/

Note these are not supported by Red Hat's official support channels.
Read the README file before using them.
Comment 8 Richard W.M. Jones 2012-04-26 09:16:11 EDT
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
libguestfs has been rebased to a more recent upstream stable version.  This new version has many new features and bug fixes, but remains backwards compatible with versions from earlier RHEL 6 releases.
Comment 12 errata-xmlrpc 2012-06-20 02:59:33 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2012-0774.html